Subject: Re: [PATCH] sky2: safer transmit ring cleaning (v2)

From: Jarek Poplawski <[email-masked]>
Date: Tue, 12 Jan 2010 20:50:04 +0100

On Tue, Jan 12, 2010 at 11:23:14AM -0800, Stephen Hemminger wrote:
> On Tue, 12 Jan 2010 20:16:11 +0100
> Jarek Poplawski <[email-masked]> wrote:
> 
> > > 
> > > What is supposed to happen:
> > >   * restart sky2_restart calls napi_disable while cleaning  
> > 
> > Yes, but it's after the detach; similarly to sky2_suspend().
> > (I'm not sure how safe vs such re-enabling is sky2_set_ringparam().
> 
> set_ringparam happens under rtnl_lock() so reset and ringparams can't
> conflict.

I didn't mean reset. I meant tx (dev_queue_xmit()) during ringparams.

> 
> > 
> > >   * dev_close we can't call napi_disable() because of two ports
> > >     sharing same NAPI, so napi_synchronize() is used to make sure that
> > >     any NAPI running on other CPU has completed.  
> > 
> > So it seems still endangered.
> 
> It was but not in revised v2 patch.

Sorry, I meant sky2_down() (except in dev_close()).

Jarek P.